#include <thread>
#include <future>
#include <cstdlib>
#include <cstdio>
#include <unistd.h>

struct Task {
    size_t i;
    std::promise<void> prom;
    std::future<void> fut;
};

void thread_task(Task *t) {
    size_t tmp = rand() % 5;
    sleep(16 - t->i);
    t->fut.get();

    printf("%ld\n", t->i);
    t->prom.set_value();
}


int main(int argc, char **argv) {
    size_t n=16;
    std::thread workers[n];
    Task tasks[n];

    std::promise<void> trigger_prom;
    std::promise<void> *prev_prom = &trigger_prom;
    for (size_t i=0; i<n; i++) {
        tasks[i].i = i;
        tasks[i].fut = prev_prom->get_future();
        prev_prom = &(tasks[i].prom);

        if (i == 0) trigger_prom.set_value();

        workers[i] = std::thread(thread_task, &(tasks[i]));
    }

    for (size_t i=0; i<n; i++) {
        workers[i].join();
    }
}
